// A Processing implementation of the legendary BASIC program
// 10 PRINT CHR$(205.5+RND(1)); : GOTO 10
// see http://nickm.com/trope_tank/10_PRINT_121114.pdf

// A simplified visualization that shows the relationship 
// between random numbers and the choice of slash versus
// backslash.  Slide the mouse left and right over the 
// sketch window to change the amount of bias, affecting
// the choice of slash or backslash in each cell.

int current_seed = 0;

void setup()
{
  size( 400, 400 );
  strokeCap( ROUND );
  strokeWeight( 70 );
  stroke( 0 );
  noFill();
  textSize( 24 );
}

void draw()
{
  randomSeed( current_seed );
  float t = norm( mouseX, 0, width );
  background( 255 );
  noStroke();
  for ( int y = 0; y < height; y += 200 ) {
    for ( int x = 0; x < width; x += 200 ) {
      if ( x != y ) {
        fill( 200 );
      } else {
        fill( 255 );
      }
      rect( x, y, x + 200, y + 200 );
    }
  }

  for ( int y = 0; y < height; y += 200 ) {
    for ( int x = 0; x < width; x += 200 ) {
      stroke( 0 );
      noFill();
      float r = random( 1 );

      if ( r <= t ) {
        line( x, y, x + 200, y + 200 );
      } else {
        line( x + 200, y, x, y + 200 );
      }

      fill( 255, 0, 0 );
      noStroke();
      // Show the random number chosen for 
      // each cell -- display it inside the
      // cell.
      text( "" + r, x + 10, y + 20 );
    }
  }

  text( "BIAS: " + t, width/2-50, height-5 );
}

void keyPressed()
{
  current_seed = millis();
  println( "New seed is " + current_seed );
}