// Craig S. Kaplan
//
// The starting point for the "10 Print" design, inspired by 
// a Sol Lewitt print and the famous Commodore 64 demo.  Draw
// a grid of random slashes and backslashes.  Use the 
// "noloop()/loop() trick" to stop the sketch and restart
// it when the user presses a key, generating a new design 
// based on new random numbers.

void setup()
{
  size( 800, 800 );
}

void draw()
{
  background( 255 );
  strokeWeight( 15 );
  noFill();

  for ( int row = 0; row < 20; ++row ) {
    for ( int col = 0; col < 20; ++col ) {
      float x = col * 40;
      float y = row * 40;

      if ( random( 1 ) < 0.5 ) {
        // Draw a line from NW to SE
        line( x, y, x + 40, y + 40 );
      } else {
        // Draw a line from NE to SW
        line( x + 40, y, x, y + 40 );
      }
    }
  }
  
  noLoop();
}

void keyPressed()
{
  loop();
}